/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Indexes;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Keys;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records.InvoiceItemToCcidRecord;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;
import org.jooq.types.UInteger;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class InvoiceItemToCcid extends TableImpl<InvoiceItemToCcidRecord> {

    private static final long serialVersionUID = 1645917542;

    /**
     * The reference instance of <code>INVOICE_ITEM_TO_CCID</code>
     */
    public static final InvoiceItemToCcid INVOICE_ITEM_TO_CCID = new InvoiceItemToCcid();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<InvoiceItemToCcidRecord> getRecordType() {
        return InvoiceItemToCcidRecord.class;
    }

    /**
     * The column <code>INVOICE_ITEM_TO_CCID.id</code>.
     */
    public final TableField<InvoiceItemToCcidRecord, UInteger> ID = createField("id", org.jooq.impl.SQLDataType.INTEGERUNSIGNED.nullable(false).identity(true), this, "");

    /**
     * The column <code>INVOICE_ITEM_TO_CCID.ID_CCID_METADATA</code>.
     */
    public final TableField<InvoiceItemToCcidRecord, Long> ID_CCID_METADATA = createField("ID_CCID_METADATA", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "");

    /**
     * The column <code>INVOICE_ITEM_TO_CCID.ID_INVOICE_ITEM</code>.
     */
    public final TableField<InvoiceItemToCcidRecord, Integer> ID_INVOICE_ITEM = createField("ID_INVOICE_ITEM", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>INVOICE_ITEM_TO_CCID.VALORE</code>.
     */
    public final TableField<InvoiceItemToCcidRecord, BigDecimal> VALORE = createField("VALORE", org.jooq.impl.SQLDataType.DECIMAL(34, 20).nullable(false).defaultValue(org.jooq.impl.DSL.inline("0.00000000000000000000", org.jooq.impl.SQLDataType.DECIMAL)), this, "");

    /**
     * The column <code>INVOICE_ITEM_TO_CCID.PERIODO_RIPARTIZIONE_ID</code>.
     */
    public final TableField<InvoiceItemToCcidRecord, Long> PERIODO_RIPARTIZIONE_ID = createField("PERIODO_RIPARTIZIONE_ID", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>INVOICE_ITEM_TO_CCID.VALORE_APPLICATO_IN_CHIUSURA</code>.
     */
    public final TableField<InvoiceItemToCcidRecord, BigDecimal> VALORE_APPLICATO_IN_CHIUSURA = createField("VALORE_APPLICATO_IN_CHIUSURA", org.jooq.impl.SQLDataType.DECIMAL(34, 20).defaultValue(org.jooq.impl.DSL.inline("0.00000000000000000000", org.jooq.impl.SQLDataType.DECIMAL)), this, "");

    /**
     * The column <code>INVOICE_ITEM_TO_CCID.OPERAZIONE</code>.
     */
    public final TableField<InvoiceItemToCcidRecord, String> OPERAZIONE = createField("OPERAZIONE", org.jooq.impl.SQLDataType.VARCHAR(32), this, "");

    /**
     * Create a <code>INVOICE_ITEM_TO_CCID</code> table reference
     */
    public InvoiceItemToCcid() {
        this(DSL.name("INVOICE_ITEM_TO_CCID"), null);
    }

    /**
     * Create an aliased <code>INVOICE_ITEM_TO_CCID</code> table reference
     */
    public InvoiceItemToCcid(String alias) {
        this(DSL.name(alias), INVOICE_ITEM_TO_CCID);
    }

    /**
     * Create an aliased <code>INVOICE_ITEM_TO_CCID</code> table reference
     */
    public InvoiceItemToCcid(Name alias) {
        this(alias, INVOICE_ITEM_TO_CCID);
    }

    private InvoiceItemToCcid(Name alias, Table<InvoiceItemToCcidRecord> aliased) {
        this(alias, aliased, null);
    }

    private InvoiceItemToCcid(Name alias, Table<InvoiceItemToCcidRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> InvoiceItemToCcid(Table<O> child, ForeignKey<O, InvoiceItemToCcidRecord> key) {
        super(child, key, INVOICE_ITEM_TO_CCID);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.INVOICE_ITEM_TO_CCID_FK_TO_CCID_METADATA, Indexes.INVOICE_ITEM_TO_CCID_FK_TO_INVOICE_ITEM, Indexes.INVOICE_ITEM_TO_CCID_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<InvoiceItemToCcidRecord, UInteger> getIdentity() {
        return Keys.IDENTITY_INVOICE_ITEM_TO_CCID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<InvoiceItemToCcidRecord> getPrimaryKey() {
        return Keys.KEY_INVOICE_ITEM_TO_CCID_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<InvoiceItemToCcidRecord>> getKeys() {
        return Arrays.<UniqueKey<InvoiceItemToCcidRecord>>asList(Keys.KEY_INVOICE_ITEM_TO_CCID_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<InvoiceItemToCcidRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<InvoiceItemToCcidRecord, ?>>asList(Keys.FK_TO_CCID_METADATA, Keys.FK_TO_INVOICE_ITEM);
    }

    public CcidMetadata ccidMetadata() {
        return new CcidMetadata(this, Keys.FK_TO_CCID_METADATA);
    }

    public InvoiceItem invoiceItem() {
        return new InvoiceItem(this, Keys.FK_TO_INVOICE_ITEM);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceItemToCcid as(String alias) {
        return new InvoiceItemToCcid(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceItemToCcid as(Name alias) {
        return new InvoiceItemToCcid(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public InvoiceItemToCcid rename(String name) {
        return new InvoiceItemToCcid(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public InvoiceItemToCcid rename(Name name) {
        return new InvoiceItemToCcid(name, null);
    }
}
